//WalkingStick.cs
datablock AudioProfile(WalkingStickDrawSound)
{
   filename    = "add-ons/weapon_sword/swordDraw.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(WalkingStickHitSound)
{
   filename    = "add-ons/weapon_sword/swordHit.wav";
   description = AudioClosest3d;
   preload = true;
};

//Decals
datablock DecalData(walkingstickCI)
{
   textureName = "./CI_walkingstick";
};   

datablock DecalData(walkingstickIcon)
{
   textureName = "./icon_walkingstick";
};   

//shell
datablock DebrisData(walkingstickDebris)
{
	shapeFile = "./stickdebris.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};


//effects
datablock ParticleData(WalkingStickExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 1.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 300;
   textureName          = "base/data/particles/chunk";
   colors[0]     = "0.7 0.7 0.9 0.9";
   colors[1]     = "0.9 0.9 0.9 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.25;
};

datablock ParticleEmitterData(WalkingStickExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "WalkingStickExplosionParticle";

   uiName = "WalkingStick Hit";
};

datablock ExplosionData(WalkingStickExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   soundProfile = WalkingStickHitSound;

   particleEmitter = WalkingStickExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "00.0 0.2 0.6";
   lightEndColor = "0 0 0";
};


//projectile
AddDamageType("WalkingStick",   '<bitmap:add-ons/Weapon_Walking_Stick/CI_WalkingStick> %1',    '%2 <bitmap:add-ons/Weapon_Walking_Stick/CI_WalkingStick> %1',0.75,1);
datablock ProjectileData(WalkingStickProjectile)
{
   directDamage        = 35;
   directDamageType  = $DamageType::WalkingStick;
   radiusDamageType  = $DamageType::WalkingStick;
   explosion           = WalkingStickExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "WalkingStick Slice";
};


//////////
// item //
//////////
datablock ItemData(WalkingStickItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Stick.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Walking Stick";
	iconName = "./icon_WalkingStick";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = WalkingStickImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(WalkingStickImage)
{
   // Basic Item properties
   shapeFile = "./Stick.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = WalkingStickItem;
   ammo = " ";
   projectile = WalkingStickProjectile;
   projectileType = Projectile;
   
   	casing = walkingstickDebris;
	shellExitDir        = "0 0 -1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = WeaponswitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Draw";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "ReadyDrawed";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";
	
		stateName[6]			= "Draw";
	stateTransitionOnTimeout[6]	= "ReadyDrawed";
	stateSound[6]                    = WalkingStickDrawSound;
	stateSequence[6]                = "Draw";
	stateEjectShell[6]       = true;
	stateTimeoutValue[6]            = 0.5;
	
		stateName[7]                     = "ReadyDrawed";
	stateTransitionOnTriggerDown[7]  = "Prefire";
	stateAllowImageChange[7]         = true;



};

function WalkingStickImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function WalkingStickImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}